#include "stdafx.h"
#include "JSAPrivate.hpp"

namespace JSA
{
    HashNodeAllocator::HashNodeAllocator(const DictionaryOptions & opt) : m_pHashNodes(0),m_nNodeCount(0),m_nCurrentNode(0)
    {
        m_pHashNodes = new HashNode[opt.WindowSize];

        if (m_pHashNodes != 0)
        {
            m_nNodeCount = opt.WindowSize;
        }
    }

    HashNodeAllocator::~HashNodeAllocator()
    {
        if (m_pHashNodes != 0)
        {
            delete [] m_pHashNodes;
        }
    }

    HashNode * HashNodeAllocator::GetNode()
    {
        HashNode * pRetValue = 0;

        if (m_pHashNodes != 0)
        {
            pRetValue = &m_pHashNodes[m_nCurrentNode];

            CHashList * pHashList = pRetValue->OwnerList;

            if (pHashList != 0)
            {
                pHashList->Remove(pRetValue);
            }

            ++m_nCurrentNode;

            if (m_nCurrentNode == m_nNodeCount)
            {
                m_nNodeCount = 0;
            }
        }

        return pRetValue;
    }
}
